--- old/usr/src/lib/libzfs/common/libzfs_util.c	Fri Dec 21 21:48:42 2012
+++ new/usr/src/lib/libzfs/common/libzfs_util.c	Fri Dec 21 21:48:42 2012
@@ -1265,6 +1265,16 @@
 			    "use 'none' to disable quota/refquota"));
 			goto error;
 		}
+
+		/*
+		 * Special handling for "*_limit=none". In this case it's not
+		 * 0 but UINT64_MAX.
+		 */
+		if ((type & ZFS_TYPE_DATASET) && isnone &&
+		    (prop == ZFS_PROP_FILESYSTEM_LIMIT ||
+		    prop == ZFS_PROP_SNAPSHOT_LIMIT)) {
+			*ivalp = UINT64_MAX;
+		}
 		break;
 
 	case PROP_TYPE_INDEX:
